package org.xtext.example.mydsl.ide.highlighting

import com.google.inject.Inject
import org.eclipse.emf.ecore.EObject
import org.eclipse.xtext.ide.editor.syntaxcoloring.DefaultSemanticHighlightingCalculator
import org.eclipse.xtext.ide.editor.syntaxcoloring.IHighlightedPositionAcceptor
import org.eclipse.xtext.service.OperationCanceledManager
import org.eclipse.xtext.util.CancelIndicator
import org.xtext.example.mydsl.myDsl.Greeting
import org.xtext.example.mydsl.myDsl.MyDslPackage

import static org.xtext.example.mydsl.ide.highlighting.MyDslHighlightingStyles.*

class MyDslSemanticHighlightingCalculator extends DefaultSemanticHighlightingCalculator {

	@Inject
	OperationCanceledManager operationCanceledManager

	override protected highlightElement(
		EObject object,
		IHighlightedPositionAcceptor acceptor,
		CancelIndicator cancelIndicator
	) {
		operationCanceledManager.checkCanceled(cancelIndicator)
		switch object {
			Greeting: {
				if (object.name == 'World') {
					highlightFeature(acceptor, object, MyDslPackage.Literals.GREETING__NAME, WORLD_GREETING)
				}
				return true
			}
			default:
				return super.highlightElement(object, acceptor, cancelIndicator)
		}
	}

}
