package org.xtext.example.mydsl.idea.liveTemplates

import com.intellij.codeInsight.template.EverywhereContextType
import com.intellij.codeInsight.template.TemplateContextType
import com.intellij.psi.PsiFile
import org.xtext.example.mydsl.idea.lang.MyDslLanguage
import org.xtext.example.mydsl.myDsl.MyDslPackage

abstract class AbstractMyDslTemplateContextType extends AbstractXtextTemplateContextType {

	protected new(String id, String presentableName, Class<? extends TemplateContextType> parent) {
		super(MyDslLanguage.INSTANCE, id, presentableName, parent)
	}

	static class Generic extends AbstractMyDslTemplateContextType {

		new() {
			super("mydsl.generic", "MyDsl", EverywhereContextType)
		}
		
		override internalIsInContext(PsiFile file, int offset) {
			true
		}

	}
	
	static class Greeting extends AbstractMyDslTemplateContextType {
	
		new() {
			super("mydsl.greeting", "Greeting", Generic)
			registerFollowElementsfor(MyDslPackage.Literals.MODEL__GREETINGS)
		}
		
	}

}
