package org.xtext.example.mydsl.ide.highlighting;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.ide.editor.syntaxcoloring.DefaultSemanticHighlightingCalculator;
import org.eclipse.xtext.ide.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.service.OperationCanceledManager;
import org.eclipse.xtext.util.CancelIndicator;
import org.xtext.example.mydsl.ide.highlighting.MyDslHighlightingStyles;
import org.xtext.example.mydsl.myDsl.Greeting;
import org.xtext.example.mydsl.myDsl.MyDslPackage;

@SuppressWarnings("all")
public class MyDslSemanticHighlightingCalculator extends DefaultSemanticHighlightingCalculator {
  @Inject
  private OperationCanceledManager operationCanceledManager;
  
  @Override
  protected boolean highlightElement(final EObject object, final IHighlightedPositionAcceptor acceptor, final CancelIndicator cancelIndicator) {
    this.operationCanceledManager.checkCanceled(cancelIndicator);
    boolean _matched = false;
    if (!_matched) {
      if (object instanceof Greeting) {
        _matched=true;
        String _name = ((Greeting)object).getName();
        boolean _equals = Objects.equal(_name, "World");
        if (_equals) {
          this.highlightFeature(acceptor, object, MyDslPackage.Literals.GREETING__NAME, MyDslHighlightingStyles.WORLD_GREETING);
        }
        return true;
      }
    }
    return super.highlightElement(object, acceptor, cancelIndicator);
  }
}
