package org.xtext.example.mydsl.idea.structureview

import com.google.inject.Singleton
import com.intellij.icons.AllIcons
import com.intellij.ide.projectView.PresentationData
import org.eclipse.xtext.idea.structureview.DefaultStructureViewTreeElementProvider
import org.eclipse.xtext.idea.structureview.EObjectTreeElement
import org.xtext.example.mydsl.myDsl.Model
import org.xtext.example.mydsl.myDsl.MyDslPackage

@Singleton
class MyDslStructureViewTreeElementProvider extends DefaultStructureViewTreeElementProvider {

	override protected _buildChildren(EObjectTreeElement it) {
		switch object {
			Model: {
				addChild(
					object.createEStructuralFeatureTreeElement(
						MyDslPackage.Literals.MODEL__GREETINGS,
						xtextFile,
						false,
						new PresentationData => [
							icon = AllIcons.General.SecondaryGroup
							presentableText = 'Greetings'
						]
					)
				)
			}
			default:
				super._buildChildren(it)
		}
	}

}
