package org.xtext.example.mydsl.idea.intentions;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import com.google.inject.Provider;
import com.google.inject.Singleton;
import com.intellij.lang.annotation.Annotation;
import com.intellij.openapi.editor.Document;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.project.Project;
import com.intellij.psi.PsiDocumentManager;
import com.intellij.psi.PsiFile;
import com.intellij.util.IncorrectOperationException;
import org.eclipse.xtext.idea.intentions.AbstractIssueIntentionAction;
import org.eclipse.xtext.idea.intentions.IdeaIntentionsProvider;
import org.eclipse.xtext.validation.Issue;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtext.example.mydsl.validation.MyDslValidator;

@Singleton
@SuppressWarnings("all")
public class MyDslIntentionsProvider extends IdeaIntentionsProvider {
  public static class CapitalizeNameIntentionAction extends AbstractIssueIntentionAction {
    @Override
    public String getText() {
      return "Capitalize name";
    }
    
    @Override
    public void invoke(final Project project, final Editor editor, final PsiFile file) throws IncorrectOperationException {
      Document _document = editor.getDocument();
      CharSequence _charsSequence = _document.getCharsSequence();
      Issue _issue = this.getIssue();
      Integer _offset = _issue.getOffset();
      char _charAt = _charsSequence.charAt((_offset).intValue());
      final String firstLetter = Character.valueOf(_charAt).toString();
      Document _document_1 = editor.getDocument();
      Issue _issue_1 = this.getIssue();
      Integer _offset_1 = _issue_1.getOffset();
      Issue _issue_2 = this.getIssue();
      Integer _offset_2 = _issue_2.getOffset();
      int _plus = ((_offset_2).intValue() + 1);
      String _upperCase = firstLetter.toUpperCase();
      _document_1.replaceString((_offset_1).intValue(), _plus, _upperCase);
      PsiDocumentManager _instance = PsiDocumentManager.getInstance(project);
      Document _document_2 = editor.getDocument();
      _instance.commitDocument(_document_2);
    }
  }
  
  @Inject
  private Provider<MyDslIntentionsProvider.CapitalizeNameIntentionAction> invalidNameIntentionActionProvider;
  
  @Override
  public void registerFixes(final Annotation anno, final Issue issue) {
    String _code = issue.getCode();
    boolean _equals = Objects.equal(MyDslValidator.INVALID_NAME, _code);
    if (_equals) {
      MyDslIntentionsProvider.CapitalizeNameIntentionAction _get = this.invalidNameIntentionActionProvider.get();
      final Procedure1<MyDslIntentionsProvider.CapitalizeNameIntentionAction> _function = new Procedure1<MyDslIntentionsProvider.CapitalizeNameIntentionAction>() {
        @Override
        public void apply(final MyDslIntentionsProvider.CapitalizeNameIntentionAction it) {
          it.setIssue(issue);
        }
      };
      MyDslIntentionsProvider.CapitalizeNameIntentionAction _doubleArrow = ObjectExtensions.<MyDslIntentionsProvider.CapitalizeNameIntentionAction>operator_doubleArrow(_get, _function);
      anno.registerFix(_doubleArrow);
    }
  }
}
