package org.xtext.example.mydsl.idea.liveTemplates;

import com.intellij.codeInsight.template.EverywhereContextType;
import com.intellij.codeInsight.template.TemplateContextType;
import com.intellij.psi.PsiFile;
import org.xtext.example.mydsl.idea.lang.MyDslLanguage;
import org.xtext.example.mydsl.idea.liveTemplates.AbstractXtextTemplateContextType;
import org.xtext.example.mydsl.myDsl.MyDslPackage;

@SuppressWarnings("all")
public abstract class AbstractMyDslTemplateContextType extends AbstractXtextTemplateContextType {
  public static class Generic extends AbstractMyDslTemplateContextType {
    public Generic() {
      super("mydsl.generic", "MyDsl", EverywhereContextType.class);
    }
    
    @Override
    public boolean internalIsInContext(final PsiFile file, final int offset) {
      return true;
    }
  }
  
  public static class Greeting extends AbstractMyDslTemplateContextType {
    public Greeting() {
      super("mydsl.greeting", "Greeting", AbstractMyDslTemplateContextType.Generic.class);
      this.registerFollowElementsfor(MyDslPackage.Literals.MODEL__GREETINGS);
    }
  }
  
  protected AbstractMyDslTemplateContextType(final String id, final String presentableName, final Class<? extends TemplateContextType> parent) {
    super(MyDslLanguage.INSTANCE, id, presentableName, parent);
  }
}
