package org.xtext.example.mydsl.idea.presentation;

import com.google.inject.Singleton;
import com.intellij.psi.PsiElement;
import java.util.Arrays;
import javax.swing.Icon;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.idea.presentation.DefaultItemPresentationProvider;
import org.xtext.example.mydsl.idea.icons.MyDslIcons;
import org.xtext.example.mydsl.myDsl.Greeting;

@Singleton
@SuppressWarnings("all")
public class MyDslItemPresentationProvider extends DefaultItemPresentationProvider {
  protected String _text(final Greeting it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("A greeting to ");
    String _name = it.getName();
    _builder.append(_name, "");
    return _builder.toString();
  }
  
  protected Icon _image(final Greeting it) {
    return MyDslIcons.GREETING;
  }
  
  public String text(final Object it) {
    if (it instanceof Greeting) {
      return _text((Greeting)it);
    } else if (it instanceof EObject) {
      return _text((EObject)it);
    } else if (it == null) {
      return _text((Void)null);
    } else if (it != null) {
      return _text(it);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it).toString());
    }
  }
  
  public Icon image(final Object it) {
    if (it instanceof Greeting) {
      return _image((Greeting)it);
    } else if (it instanceof PsiElement) {
      return _image((PsiElement)it);
    } else if (it instanceof EObject) {
      return _image((EObject)it);
    } else if (it == null) {
      return _image((Void)null);
    } else if (it != null) {
      return _image(it);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it).toString());
    }
  }
}
